<?php
  // author: KITA Toshihiro http://tkita.net/
  // @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
global $gs_command, $convert_command, $zbarimg_command, $pdftk_command, $tmpd, $mailmsg;
global $DB, $CFG;

// needs zbarimg command from http://zbar.sourceforge.net/
// built by ./configure --with-x=no --enable-video=no --with-python=no --with-gtk=no --with-qt=no
// pdftk command is commonly installable by yum or apt-get, etc.

$inputfolder= "/home/pdf2moodle/pdfs/";  // Where the PDF files are


$zbarimg_command= "/usr/local/bin/zbarimg ";
$convert_command= "convert";
$gs_command= "gs";
$pdftk_command= "pdftk";

$tmpd= "/tmp/";  // The directory for temporary files


$warning_mailto= $CFG->supportemail;  

if (!defined('MOODLE_INTERNAL')) {
  die('Direct access to this script is forbidden.');  // It must be included from a Moodle page
}

//require_once(dirname(__FILE__) . '/../../config.php');
//$dirroot= $CFG->dirroot;
//$datdir=  $CFG->dataroot;
//require_once($dirroot."/config.php");
//require_once($dirroot."/mod/assignment/lib.php");
//require_once($dirroot.'/mod/assignment/type/uploadsingle/assignment.class.php');
//require_once($CFG->dirroot."/mod/assign/lib.php");
//require_once($dirroot.'/mod/assign/type/uploadsingle/assignment.class.php');

$mailmsg = "";
if (!is_readable($inputfolder)){
  $mailmsg .= "cannot read $inputfolder .\n";
  mail($warning_mailto,'pdf2submission (err)',$mailmsg);
}
if (!is_writable($inputfolder)){
  $mailmsg .= "not writable: $inputfolder .\n";
  mail($warning_mailto,'pdf2submission (error)',$mailmsg);
}
// process all the PDF files in $inputfolder
$dir = dir($inputfolder);
while(($ent = $dir->read()) !== FALSE){
  //  if(eregi(".pdf$",$ent)){
  if(preg_match('/.pdf$/',$ent)){
    $origfilename= $ent;
    $origfilenamebase= str_replace(".pdf","",$origfilename);
    $currentfolder = "$inputfolder/$origfilenamebase/";
    if ( !file_exists($currentfolder) ){
      $ret0= split_into_files_of_each_user($currentfolder, $inputfolder.$origfilename);
      if ($mailmsg != ""){  mail($warning_mailto,'pdf2submission(in progress..)',$mailmsg); }
      if ($ret0>1){  exec("touch $currentfolder/splitdone");  }
    }

    if ( !file_exists("$currentfolder/splitdone") ){  break; }
    $subret= 1; $submiterr= FALSE;
    // rescan currentfolder and submit
    $dir3 = dir($currentfolder);

    while(($ent3 = $dir3->read()) !== FALSE){
      //      if(eregi(".pdf$",$ent3)){
      if(preg_match('/.pdf$/',$ent3)){
	$filename= $ent3;
	//	$subret= submit_file($filename, $currentfolder, $datdir);
	$subret= submit_file($filename, $currentfolder);
	if ($subret<0){ $submiterr= TRUE; }
      }
    } // while(($ent3 = $dir3->read()) !== FALSE)..

    if (!$submiterr){
      $tmpcf1= rtrim($currentfolder,"/");
      rename($tmpcf1, $tmpcf1."-".uniqid());
      unlink($inputfolder.$origfilename); // remove if successfully submitted
    } 
  }
}
if ($mailmsg != ""){  mail($warning_mailto,'pdf2submission',$mailmsg); }



function split_into_files_of_each_user($currentfolder,$origfile){
  global $pdftk_command, $tmpd, $mailmsg;
  $burstfolder= $currentfolder . "burst/";
  exec("mkdir $currentfolder");
  exec("mkdir $burstfolder");
  exec("cd $burstfolder; $pdftk_command $origfile burst");
  // as default, burst to pg_0001.pdf, pg_0002.pdf, ...
  for($co=1; $co<10000; $co++){
    $filename= sprintf("pg_%04d.pdf",$co);
    $filenamefull= $burstfolder.$filename; 
    if (!file_exists($filenamefull)){  break;  }
    list($asno,$userid,$coursename,$username) = decode_qr($filenamefull);
    if ( is_null($userid) || is_null($asno) ){ // No QR or read err
      // append to previous QRcode sheet
      if (!is_null($lastQRfile)){
	$tmpcat1 = $tmpd."/pdfscan-cat".uniqid().".pdf";
	exec("$pdftk_command $lastQRfile $filenamefull cat output $tmpcat1");
	copy($tmpcat1, $lastQRfile);  unlink($tmpcat1);
	// remove concatenated file (actually, moved to 'cat' folder) 
	exec("mkdir $burstfolder"."/cat/");
	copy($filenamefull, $burstfolder."/cat/".$filename);
	unlink($filenamefull);
      }
    }else{ // sheet with QRcode
      // Rename the files after the recognized userID, etc.
      $newfname= $asno."__".$userid."__".$coursename."__".$username."__.pdf";
      $lastQRfile= $currentfolder.$newfname;
      if (copy($filenamefull, $lastQRfile)){
	unlink($filenamefull);
      }
      $mailmsg .= ",".$newfname."\n";
    }
  } // for($co=1; $co<10000; $co++)
  return $co;
}


function decode_qr($pdffile){
  global $gs_command, $convert_command, $zbarimg_command, $tmpd, $mailmsg;
  $tmpjpg1= $tmpd."/pdfscan1".uniqid().".jpg";
  $tmpjpg2= $tmpd."/pdfscan2".uniqid().".jpg";
  $execcmd1="$gs_command -dSAFER -dBATCH -dNOPAUSE -sDEVICE=jpeg -r200 -sOutputFile=$tmpjpg1 -dFirstPage=1 -dLastPage=1 $pdffile";
  exec($execcmd1);
  // you may need some tuning for preprocessing QR code image
  $execcmd2="$convert_command -blur 2 $tmpjpg1 $tmpjpg2";
  exec($execcmd2);
  $execdmtx = "$zbarimg_command -q --raw $tmpjpg2";
  $outstr = $userid = $asno = NULL;
  exec($execdmtx,$outstr,$ret);
  list($asno,$userid,$coursename,$username) = preg_split( '/[,\n]/',implode("",$outstr) );
  //  list($userid,$asno,$coursename,$username) = preg_split( '/[,\n]/',implode("",$outstr) );

  $mailmsg .= "\npdfscan.php, " . $execcmd1 .", " .$execcmd2 .", " . $execdmtx . ", (" . implode("",$outstr) . "), // userid:" . $userid . ",asno:" . $asno . ",". $coursename . "," . $username . ",";
  //  unlink($tmpjpg1);  unlink($tmpjpg2);  ////////////
  return array($asno,$userid,$coursename,$username);
}


//function submit_file($filename,$currentfolder,$datdir){
function submit_file($filename,$currentfolder){
  global $mailmsg;
  global $DB,$CFG,$USER;

  require_once($CFG->dirroot."/mod/assign/lib.php");

  // filename to asno, uid, ...
  list($asno,$userid,$coursename,$username) = preg_split( '/__/',$filename );
  $mailmsg.=  $filename.": ".$asno." ".$userid." ".$coursename." ".$username."\n";
  //  $assignment = $DB->get_record("assignment", array("id", $asno));
  $assignment = $DB->get_record("assign", array("id"=>$asno));
  $courseid= $assignment->course;
  if ( is_null($courseid) || $courseid=="" ){ return -4; }


  // copy the file
  /*
  $outputfolder= $datdir."/".$courseid."/moddata/assignment/".$asno."/".$userid."/";
  exec("mkdir -p $outputfolder");
  if ( file_exists($outputfolder.$filename) ){
    $mailmsg.= "*ERROR: $outputfolder$filename exists. do not copy the same submission twice.\n\n";
    return -2;
  }else{
    if ( copy($currentfolder.$filename, $outputfolder.$filename) ){
      //      chown($outputfolder.$filename,"apache");
      unlink($currentfolder.$filename);
    }else{
      $mailmsg.= "*ERROR: copy to assignment folder failed.\n\n";
      return -3;  // do not submit
    }
  }
  */

  $course = $DB->get_record("course", array("id"=>$assignment->course));
  //  $cm = get_coursemodule_from_instance("assignment", $assignment->id, $course->id);
  $cm = get_coursemodule_from_instance("assign", $assignment->id, 0, false, MUST_EXIST);
  $context = context_module::instance($cm->id);
  $assign = new assign($context,$cm,$course);

  if ( file_exists("$currentfolder/file_create_err") ){  return -6; }

  // from assign/locallib.php get_user_submission()
  $submission = new stdClass();
  $submission->assignment   = $assign->get_instance()->id;
  $submission->userid       = $userid;
  $submission->timecreated = time();
  $submission->timemodified = $submission->timecreated;
  $submission->status = ASSIGN_SUBMISSION_STATUS_SUBMITTED;
  $sid = $DB->insert_record('assign_submission', $submission);
  $submission->id = $sid;

  // copy the file to submit
  // code from http://docs.moodle.org/dev/File_API
  //  $context = get_context_instance(CONTEXT_COURSE, $preferences->backup_course);
  $fs = get_file_storage();
  $file_record = array(
       'contextid'=>$context->id, 
       'component'=>'assignsubmission_file',
       'filearea'=>ASSIGNSUBMISSION_FILE_FILEAREA,
       'itemid'=>$submission->id,
       'filepath'=>'/',
       'filename'=>$filename,
       'timecreated'=>time(),
       'timemodified'=>time(),
       'userid'=>$userid
  );
  if ($fs->create_file_from_pathname($file_record, $currentfolder.$filename)){
    unlink($currentfolder.$filename);
  }else{
    exec("touch $currentfolder/file_create_err");
    return -5;
  }
  // from assign/submission/file/locallib.php save()
  $filesubmission = new stdClass();
  //  $filesubmission->numfiles = $this->count_files($submission->id, ASSIGNSUBMISSION_FILE_FILEAREA);
  $filesubmission->numfiles = 1;
  $filesubmission->submission = $submission->id;
  $filesubmission->assignment = $assign->get_instance()->id;
  $DB->insert_record('assignsubmission_file', $filesubmission);

  $mailmsg.=  "*** submitted : $filename\n\n";
  return 1;
}

?>
